.386
.model flat,stdcall
option casemap:none

include         \masm32\include\windows.inc
include         \masm32\include\kernel32.inc
include         \masm32\include\user32.inc
include         \masm32\include\masm32.inc

includelib      \masm32\lib\kernel32.lib
includelib      \masm32\lib\user32.lib
includelib      \masm32\lib\masm32.lib

ReadFileToMem   PROTO :DWORD,:DWORD,:DWORD
WriteFileToDisc PROTO :DWORD,:DWORD,:DWORD
FreeMemory      PROTO :DWORD

READ_SUCCESS    equ 3
WRITE_SUCCESS   equ 1

.data

welcome db 'Simple file encryptor',13,10
        db 'Version 1.0 by Vortex',13,10,13,10
        db 'Usage : encrypt sourcefile.exe destfile.ext encryption_byte'
        db 13,10,13,10,0

readerr db 'Source file read error',0
wrterr  db 'Destination file write error',0
format1 db 'Source file size = %d byte(s)',0

.data?

Mem     dd ?
Bytes   dd ?
buffer  db 64 dup(?)

.code

main PROC C argc:DWORD,argv:DWORD

LOCAL encryptor:DWORD

    mov     esi,OFFSET welcome
    cmp     argc,4
    jne     _message
    
    mov     esi,argv
    invoke  atodw,DWORD PTR [esi+12]
    
    mov     ah,al           ; create a DWORD having all bytes identical
    mov     ecx,eax
    shl     eax,16
    mov     ax,cx
    mov     encryptor,eax
    
    invoke  ReadFileToMem,DWORD PTR [esi+4],ADDR Mem,ADDR Bytes
    mov     esi,OFFSET readerr
    cmp     eax,READ_SUCCESS
    jne     _message
    
    mov     esi,Mem
    mov     edi,encryptor 
    mov     ebx,Bytes
    cmp     ebx,SIZEOF DWORD
    jb      encrypt_byte
    shr     ebx,2

encrypt_dword:

    xor     DWORD PTR [esi],edi
    add     esi,4
    dec     ebx
    jnz     encrypt_dword
    mov     edi,encryptor
    mov     ebx,Bytes
    and     ebx,3
    jz      _exit

encrypt_byte:

    xor     BYTE PTR [esi],dl
    add     esi,1
    dec     ebx
    jnz     encrypt_byte

_exit:

    mov     esi,argv
    invoke  WriteFileToDisc,DWORD PTR [esi+8],Mem,Bytes
    mov     esi,OFFSET wrterr
    cmp     eax,WRITE_SUCCESS
    jne     _freeMem
    
    invoke  wsprintf,ADDR buffer,ADDR format1,Bytes
    mov     esi,OFFSET buffer

_freeMem:

    invoke  FreeMemory,Mem

_message:

    invoke  StdOut,esi
    ret

main ENDP

END

